diff --git a/ice.c b/ice.c
index 36a67eb4f2..a54f2f2c96 100644
--- a/ice.c
+++ b/ice.c
@@ -325,9 +325,11 @@ typedef struct janus_ice_nacked_packet {
 static gboolean janus_ice_nacked_packet_cleanup(gpointer user_data) {
 	janus_ice_nacked_packet *pkt = (janus_ice_nacked_packet *)user_data;
 
-	JANUS_LOG(LOG_HUGE, "[%"SCNu64"] Cleaning up NACKed packet %"SCNu16" (SSRC %"SCNu32", vindex %d)...\n",
-		pkt->handle->handle_id, pkt->seq_number, pkt->handle->stream->video_ssrc_peer[pkt->vindex], pkt->vindex);
-	g_hash_table_remove(pkt->handle->stream->rtx_nacked[pkt->vindex], GUINT_TO_POINTER(pkt->seq_number));
+	if(pkt->handle->stream){
+		JANUS_LOG(LOG_HUGE, "[%"SCNu64"] Cleaning up NACKed packet %"SCNu16" (SSRC %"SCNu32", vindex %d)...\n",
+			pkt->handle->handle_id, pkt->seq_number, pkt->handle->stream->video_ssrc_peer[pkt->vindex], pkt->vindex);
+		g_hash_table_remove(pkt->handle->stream->rtx_nacked[pkt->vindex], GUINT_TO_POINTER(pkt->seq_number));
+	}
 
 	return G_SOURCE_REMOVE;
 }
@@ -2493,7 +2495,7 @@ static void janus_ice_cb_nice_recv(NiceAgent *agent, guint stream_id, guint comp
 								np->handle = handle;
 								np->seq_number = cur_seq->seq;
 								np->vindex = vindex;
-								GSource *timeout_source = g_timeout_source_new_seconds(5);
+								GSource *timeout_source = handle->nacked_cleanup_source = g_timeout_source_new_seconds(5);
 								g_source_set_callback(timeout_source, janus_ice_nacked_packet_cleanup, np, (GDestroyNotify)g_free);
 								g_source_attach(timeout_source, handle->mainctx);
 								g_source_unref(timeout_source);
@@ -3731,6 +3733,11 @@ static gboolean janus_ice_outgoing_traffic_handle(janus_ice_handle *handle, janu
 			g_source_unref(handle->stats_source);
 			handle->stats_source = NULL;
 		}
+		if(handle->nacked_cleanup_source) {
+			g_source_destroy(handle->nacked_cleanup_source);
+			g_source_unref(handle->nacked_cleanup_source);
+			handle->nacked_cleanup_source = NULL;
+		}
 		/* If event handlers are active, send stats one last time */
 		if(janus_events_is_enabled()) {
 			handle->last_event_stats = janus_ice_event_stats_period;
diff --git a/ice.h b/ice.h
index 8420814933..d6c798d05d 100644
--- a/ice.h
+++ b/ice.h
@@ -270,7 +270,7 @@ struct janus_ice_handle {
 	/*! \brief GLib thread for the handle and libnice */
 	GThread *thread;
 	/*! \brief GLib sources for outgoing traffic, recurring RTCP, and stats */
-	GSource *rtp_source, *rtcp_source, *stats_source;
+	GSource *rtp_source, *rtcp_source, *stats_source, *nacked_cleanup_source;
 	/*! \brief libnice ICE agent */
 	NiceAgent *agent;
 	/*! \brief Monotonic time of when the ICE agent has been created */
